#include <stdio.h>

long btol (long);   // Convert the number from Big to Little-endian
long getName (char * fileName, FILE * in);

void main (int argc, char ** argv)
{
FILE *in, *out;
void * buffer;
long l;
long files, numberOfFiles;
long offset,headerOffset,length;
char fileName[20];

if (argc < 2)
        {
        printf ("ERROR: You must supply a file name as the parameter\n");
        return;
        }

in = fopen (argv[1],"rb");

if (in == NULL)
        {
        printf ("ERROR: cannot open file %s\n",argv[1]);
        return;
        }


// Here begins the description of the header of the P2 IFF Archive:

fread (&l,4,1,in);           // "BIGF"

if (l != 0x46474942 )  // BIGF
        {
        printf ("ERROR: This doesn't seem to be a Privateer2 file archive\n");
        return;
        }

fread (&l,4,1,in);              // lenght
printf ("Length of the BIGF = %ld\n",btol(l));   // No need to keep this value

fread (&l,4,1,in);              // number of files
printf ("Number of files = %ld\n",btol(l));
numberOfFiles = btol(l);

fread (&l,4,1,in);             // header length
printf ("Header Length = %ld\n",btol(l));   // No need to keep this value either

for (files = 0; files < numberOfFiles; files++)
        {
        fread (&l,4,1,in);    // offset of the BIGF where the file starts
        offset=btol(l);

        fread (&l,4,1,in);    // file length
        length=btol(l);


        // File name: notice that the string size varies, unlike on most TRE files
        headerOffset = getName (fileName,in);

        printf ("File %ld: %s, Offset = %ld, Length = %ld\n",files,fileName,offset,length);

        fseek (in, offset, SEEK_SET);  // Simple load data and save to file.
        buffer = (void*) malloc (length);
        fread (buffer,length,1,in);

        out = fopen (fileName,"wb");
        fwrite (buffer, length,1,out);
        fclose(out);

        free (buffer);


        /* Privateer2 uses the 'zlib' Library for uncompressing data, which is
         * Copyright (C) 1995-1996 Jean-loup Gailly and Mark Adler.
         * Fortunately the authors allow it to be used freely. Feel free to complete
         * this source code by linking Jean and Mark's routines, so that the
         * extracted IFFs will not have any compressed chunks. Be sure to send
         * me a copy tho:) I frankly don't know if P2 will accept uncompressed
         * chunks but it'll be 100% human-readable that way (ie, hex-edit).
         * Also, since the authors also supply the respective compression
         * routines with the zlib package, we can compress chunks.
         * P2 editing can be very interesting now :) A separate chunk unpacker
         * is available, but i'm sure it'll become obsolete very soon.
         * 
         * zlib isn't the only compression routine used in P2: a routine
         * similar to WC3 Routine1 is used in P2 (as a matter of fact, WC3 R1
         * partially unpacked a P2 chunk). I'm calling this routine P2
         * Extract1 (P2 E1, for short). Not that it matters much what i call
         * the routines, but i have to have a way to tell them apart. It's
         * clear now that most WC games have more than one compression routine
         * (i tend to oversimplify things, so i didn't really consider that
         * possibility before working on MGIs.. but i'm rambling now). I also
         * found a 3rd compression routine (which is used for text mostly).
         * The information area will be uploaded with this when possible.
         *
         * Mario "HCl" Brito
         */
        


        fseek (in,headerOffset,SEEK_SET); // Set the file pointer back to the header

        
        }


}













long btol (long l)

{
char *c = (char*) &l;
char temp;

temp=c[0];
c[0] = c[3];
c[3] = temp;

temp=c[1];
c[1] = c[2];
c[2] = temp;

return l;
}







long getName (char * fileName, FILE * in)
{
int i;
for (i=0; ; i++)
        {
        fread (fileName+i,1,1,in);
        if (*(fileName+i) == NULL)
                break;
        }

return (ftell(in));


}

